use serde::{Deserialize, Serialize};

#[derive(Debug, Serialize, Deserialize, Clone)]
pub struct DamageType {
    message_id: String,
    scaling: DamageTypeScaling,
    exhaustion: f32,
    effects: Option<DamageTypeEffect>,
    death_message_type: Option<DamageTypeDeathMessageType>,
}

#[derive(Debug, Serialize, Deserialize, Clone)]
#[serde(rename_all = "snake_case")]
pub enum DamageTypeScaling {
    Never,
    WhenCausedByLivingNonPlayer,
    Always,
}

#[derive(Debug, Serialize, Deserialize, Clone)]
#[serde(rename_all = "snake_case")]
pub enum DamageTypeEffect {
    Hurt,
    Thorns,
    Drowning,
    Burning,
    Poking,
    Freezing,
}

#[derive(Debug, Serialize, Deserialize, Clone)]
#[serde(rename_all = "snake_case")]
pub enum DamageTypeDeathMessageType {
    Default,
    FallVariants,
    IntentionalGameDesign,
}
